#
# spec file for package mdadm
#
# Copyright (c) 2018 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           mdadm
Version:        4.0
Release:        5.3.1
BuildRequires:  binutils-devel
BuildRequires:  groff
BuildRequires:  pkgconfig
BuildRequires:  sgmltool
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(systemd)
BuildRequires:  pkgconfig(udev)
PreReq:         %fillup_prereq %insserv_prereq /sbin/mkinitrd coreutils
Recommends:     cron
Recommends:     smtp_daemon
Url:            http://www.kernel.org/pub/linux/utils/raid/mdadm/
Summary:        Utility for Configuring MD Setup
License:        GPL-2.0
Group:          System/Base
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source:         https://www.kernel.org/pub/linux/utils/raid/mdadm/%{name}-%{version}.tar.xz
Source1:        Software-RAID.HOWTO.tar.bz2
Source2:        sysconfig.mdadm
Source7:        mdadm.cron
Source10:       clustermd-confirm.sh
Source11:       69-clustermd.rules
Patch1:         0001-Makefile-Fix-date-to-be-output-in-ISO-format.patch
Patch2:         0002-imsm-fix-missing-error-message-during-migration.patch
Patch3:         0003-Fix-oddity-where-mdadm-did-not-recognise-a-relative-.patch
Patch5:         0005-mdadm-check-the-nodes-when-operate-clustered-array.patch
Patch6:         0006-examine-tidy-up-some-code.patch
Patch7:         0007-mdadm-add-man-page-for-symlinks.patch
Patch8:         0008-mdadm-add-checking-clustered-bitmap-in-assemble-mode.patch
Patch9:         0009-mdadm-Add-Wimplicit-fallthrough-0-in-Makefile.patch
Patch10:        0010-mdadm-Specify-enough-length-when-write-to-buffer.patch
Patch12:        0012-mdadm-it-doesn-t-make-sense-to-set-bitmap-twice.patch
Patch14:        0014-mdadm-Monitor-Fix-NULL-pointer-dereference-when-stat.patch
Patch15:        0015-Replace-snprintf-with-strncpy-at-some-places-to-avoi.patch
Patch16:        0016-mdadm-Forced-type-conversion-to-avoid-truncation.patch
Patch17:        0017-super1-ignore-failfast-flag-for-setting-device-role.patch
Patch18:        0018-mdadm-bitmap-fixed-typos-in-comments-of-bitmap.h.patch
Patch19:        0019-udev-md-raid-assembly.rules-Skip-non-ready-devices.patch
Patch20:        0020-Retry-HOT_REMOVE_DISK-a-few-times.patch
Patch21:        0021-mdadm-Build-check-the-level-parameter-when-build-new.patch
Patch22:        0022-Introduce-sys_hot_remove_disk.patch
Patch23:        0023-Add-force-flag-to-hot_remove_disk.patch
Patch24:        0024-Detail-handle-non-existent-arrays-better.patch
Patch25:        0025-Generic-support-for-consistency-policy-and-PPL.patch
Patch26:        0026-Detail-show-consistency-policy.patch
Patch27:        0027-imsm-PPL-support.patch
Patch28:        0028-super1-PPL-support.patch
Patch29:        0029-Add-ppl-and-no-ppl-options-for-update.patch
Patch30:        0030-Grow-support-consistency-policy-change.patch
Patch31:        0031-mdadm.h-struct-mdinfo-reorganize-ppl-elements-for-be.patch
Patch32:        0032-super1-replace-hard-coded-values-with-bit-definition.patch
Patch33:        0033-mdadm-Clean-up-some-ugly-multiple-actions-on-single-.patch
Patch34:        0034-mdadm-Fixup-a-number-of-whitespace-inconsistency-cas.patch
Patch35:        0035-util-Cosmetic-changes.patch
Patch36:        0036-Grow-Fixup-a-pile-of-cosmetic-issues.patch
Patch42:        0042-Grow-Remove-unnecessary-optimization.patch
Patch43:        0043-Grow-Do-not-shadow-an-existing-variable.patch
Patch45:        0045-imsm-use-rounded-size-for-metadata-initialization.patch
Patch46:        0046-mdadm.c-fix-compile-error-switch-condition-has-boole.patch
Patch50:        0050-Create-Fixup-bad-placement-of-logical-in-multi-line-.patch
Patch51:        0051-Create-Fixup-various-whitespace-issues.patch
Patch68:        0068-mdadm.c-fix-compile-warning-mdfd-is-uninitialized.patch
Patch72:        0072-mdopen-use-parameters-new_array-to-create-arrays-whe.patch
Patch73:        0073-mdadm-manpage-update-manpage-for-readonly-parameter.patch
Patch74:        0074-mdadm-manpage-clustered-arrays-don-t-support-array-s.patch
Patch83:        0083-maps-Terminate-modes-map-correctly.patch
Patch87:        0087-Grow_continue_command-ensure-content-is-properly-ini.patch
Patch88:        0088-systemd-mdadm-last-resort-use-ConditionPathExists-in.patch
Patch89:        0089-Detail-ensure-export-names-are-acceptable-as-shell-v.patch
Patch92:        0092-Grow-set-component-size-prior-to-array-size.patch
Patch93:        0093-Grow-don-t-allow-to-enable-PPL-when-reshape-is-in-pr.patch
Patch94:        0094-Grow-don-t-allow-array-geometry-change-with-ppl-enab.patch
Patch95:        0095-IMSM-Correct-examine-output-for-4k-disks.patch
Patch96:        0096-imsm-allow-drives-in-a-container-regardless-of-secto.patch
Patch97:        0097-imsm-allocate-buffer-to-support-maximum-sector-size.patch
Patch98:        0098-imsm-don-t-allow-disks-with-different-sector-size-in.patch
Patch99:        0099-Allow-more-spare-selection-criteria.patch
Patch100:       0100-Add-sector-size-as-spare-selection-criterion.patch
Patch101:       0101-super1-fix-sb-max_dev-when-adding-a-new-disk-in-line.patch
Patch102:       0102-super1-only-set-clustered-flag-when-bitmap-is-presen.patch
Patch103:       0103-mdcheck-add-some-logging.patch
Patch104:       0104-mdcheck-improve-cleanup.patch
Patch105:       0105-mdadm-improve-the-dlm-locking-mechanism-for-clustere.patch
Patch106:       0106-Assemble-provide-protection-when-clustered-raid-do-a.patch
Patch107:       0107-Assemble-cleanup-the-failure-path.patch
Patch1004:      1004-display-timeout-status.patch
# PATCH-FIX-SLE 0001-mdopen-modprobe-md_mod-if-it-might-be-needed.patch bsc#1059596 nfbrown@suse.com
Patch1115:      0001-mdopen-modprobe-md_mod-if-it-might-be-needed.patch

%define _udevdir %(pkg-config --variable=udevdir udev)
%define _systemdshutdowndir %{_unitdir}/../system-shutdown

%description
Mdadm is a program that can be used to control Linux md devices. It is
intended to provide all the functionality of the mdtools and raidtools
programs but with a very different interface.

%prep
%setup -q -a1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch12 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch42 -p1
%patch43 -p1
%patch45 -p1
%patch46 -p1
%patch50 -p1
%patch51 -p1
%patch68 -p1
%patch72 -p1
%patch73 -p1
%patch74 -p1
%patch83 -p1
%patch87 -p1
%patch88 -p1
%patch89 -p1
%patch92 -p1
%patch93 -p1
%patch94 -p1
%patch95 -p1
%patch96 -p1
%patch97 -p1
%patch98 -p1
%patch99 -p1
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch1004 -p1
%patch1115 -p1

%build
make %{?_smp_mflags} CC="%__cc" CXFLAGS="$RPM_OPT_FLAGS -Wno-error" SUSE=yes
cd Software-RAID.HOWTO
sgml2html Software-RAID.HOWTO.sgml
sgml2txt Software-RAID.HOWTO.sgml

%install
make install install-systemd install-udev DESTDIR=%{buildroot} SYSTEMD_DIR=%{_unitdir} UDEVDIR=%{_udevdir} SUSE=yes
rm -rf %{buildroot}/lib/udev
install -d %{buildroot}%{_var}/adm/fillup-templates
install -d %{buildroot}/usr/share/mdadm
install -m 755 misc/mdcheck %{buildroot}/usr/share/mdadm/mdcheck
install -d %{buildroot}/etc/cron.daily
install -m 755 %{S:7} %{buildroot}/etc/cron.daily/mdadm
install -m 644 %{S:2} %{buildroot}%{_var}/adm/fillup-templates/
install -m 755 %{S:10} $RPM_BUILD_ROOT/%{_udevdir}
install -m 644 %{S:11} $RPM_BUILD_ROOT/%{_udevdir}/rules.d
install -d %{buildroot}%{_systemdshutdowndir}
install -d %{buildroot}%{_sbindir}
ln -s %{_sbindir}/service %{buildroot}%{_sbindir}/rcmdmonitor

%define services mdmonitor.service

%pre
%service_add_pre %services

%post
/sbin/ldconfig
%service_add_post %services
%{?regenerate_initrd_post}
%fillup_only

%preun
%service_del_preun %services

%postun
/sbin/ldconfig
%service_del_postun %services
%{?regenerate_initrd_post}
%{insserv_cleanup}

%posttrans
%{?regenerate_initrd_posttrans}

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc COPYING ChangeLog README.initramfs TODO mdadm.conf-example mkinitramfs
%doc Software-RAID.HOWTO/Software-RAID.HOWTO*{.txt,.html}
%doc %{_mandir}/man?/*
/sbin/*
%{_sbindir}/rcmdmonitor
%dir /usr/share/mdadm
/usr/share/mdadm/*
%{_var}/adm/fillup-templates/sysconfig.mdadm
%{_udevdir}/rules.d/63-md-raid-arrays.rules
%{_udevdir}/rules.d/64-md-raid-assembly.rules
%{_udevdir}/clustermd-confirm.sh
%{_udevdir}/rules.d/69-clustermd.rules
%dir /etc/cron.daily
/etc/cron.daily/mdadm
%{_systemdshutdowndir}/mdadm.shutdown
%{_unitdir}/mdmon@.service
%{_unitdir}/mdmonitor.service
%{_unitdir}/mdadm-last-resort@.timer
%{_unitdir}/mdadm-last-resort@.service
%{_unitdir}/mdadm-grow-continue@.service
%dir %{_unitdir}/../scripts
%{_unitdir}/../scripts/mdadm_env.sh

%changelog
* Tue Mar 13 2018 gqjiang@suse.com
- Make dlm lock more reliable for cluster-md (bsc#1049126)
  0105-mdadm-improve-the-dlm-locking-mechanism-for-clustere.patch
  0106-Assemble-provide-protection-when-clustered-raid-do-a.patch
  0107-Assemble-cleanup-the-failure-path.patch
* Mon Jan 15 2018 colyli@suse.com
- 0103-mdcheck-add-some-logging.patch:
  add more logging information to mdcheck (bsc#935553):
- 0104-mdcheck-improve-cleanup.patch:
  code cleanup for mdcheck (bsc#935553)
* Mon Sep 25 2017 nfbrown@suse.com
- 0001-mdopen-modprobe-md_mod-if-it-might-be-needed.patch
  Load md module if needed when creating/assembling
  named arrays (bsc#1059596)
* Mon Aug 21 2017 colyli@suse.com
- 0102-super1-only-set-clustered-flag-when-bitmap-is-presen.patch
  (bsc#1047314)
* Sat Aug  5 2017 colyli@suse.com
- 0101-super1-fix-sb-max_dev-when-adding-a-new-disk-in-line.patch:
  super1: fix sb->max_dev when adding a new disk in linear array
  (bsc#1032802)
* Fri Jun 23 2017 colyli@suse.com
- 0095-IMSM-Correct-examine-output-for-4k-disks.patch
  (bsc#1040191)
- 0096-imsm-allow-drives-in-a-container-regardless-of-secto.patch
  (bsc#1040189)
- 0097-imsm-allocate-buffer-to-support-maximum-sector-size.patch
  (bsc#1040189)
- 0098-imsm-don-t-allow-disks-with-different-sector-size-in.patch
  (bsc#1040189)
- 0099-Allow-more-spare-selection-criteria.patch
  (bsc#1040189)
- 0100-Add-sector-size-as-spare-selection-criterion.patch
  (bsc#1040189)
  The following patches are unnecessary for SLE12-SP3 mdadm back port,
  remove them from mdadm package
-DELETE   0004-mdadm-fix-typo-in-comment.patch
-DELETE   0011-mdadm-fixed-some-trivial-typos-in-comments-of-mdadm..patch
-DELETE   0013-mdadm-mdmon-deleted-the-abort_reshape-never-invoked.patch
-DELETE   0037-util-Introduce-md_get_array_info.patch
-DELETE   0038-Incremental-Remove-redundant-call-for-GET_ARRAY_INFO.patch
-DELETE   0039-util-Introduce-md_get_disk_info.patch
-DELETE   0040-util-Introduce-md_set_array_info.patch
-DELETE   0041-md_u-Remove-some-unused-ioctl-declarations.patch
-DELETE   0044-mdadm-grow-reshape-would-be-stuck-from-raid1-to-raid.patch
-DELETE   0047-sysfs-Use-the-presence-of-sys-block-dev-md-as-indica.patch
-DELETE   0048-sysfs-Make-sysfs_init-return-an-error-code.patch
-DELETE   0049-mdadm-Create-declaring-an-existing-struct-within-sam.patch
-DELETE   0052-util-must_be_container-Use-sysfs_read-GET_VERSION-to.patch
-DELETE   0053-util-set_array_info-Simplify-code-since-md_get_versi.patch
-DELETE   0054-Assemble-Assemble-Stop-checking-kernel-md-driver-ver.patch
-DELETE   0055-Build-Stop-bothering-about-supporting-md-driver-olde.patch
-DELETE   0056-Grow-Stop-bothering-about-md-driver-versions-older-t.patch
-DELETE   0057-Detail-Stop-bothering-about-md-drivers-older-than-0..patch
-DELETE   0058-Create-Remove-all-attemps-to-handle-md-driver-older-.patch
-DELETE   0059-Manage-Remove-all-references-to-md_get_version.patch
-DELETE   0060-Query-Remove-all-references-to-md_get_version.patch
-DELETE   0061-bitmap-Remove-use-of-md_get_version.patch
-DELETE   0062-mdmon-Stop-bothering-about-md_get_version.patch
-DELETE   0063-mdopen-open_mddev-Use-md_get_array_info-to-determine.patch
-DELETE   0064-mdassemble-Use-md_get_array_info-to-check-for-valid-.patch
-DELETE   0065-Assemble-Assemble-Get-rid-of-last-use-of-md_get_vers.patch
-DELETE   0066-util-Finally-kill-off-md_get_version.patch
-DELETE   0067-mdadm-Fail-for-kernels-older-than-2.6.15.patch
-DELETE   0069-Revert-mdadm-grow-reshape-would-be-stuck-from-raid1-.patch
-DELETE   0070-Retire-mdassemble.patch
-DELETE   0071-super1-Clean-up-various-style-abuses.patch
-DELETE   0075-Assemble-Clean-up-start_array.patch
-DELETE   0076-Detail-Remove-pre-2.6-code-for-printing-info-on-rebu.patch
-DELETE   0077-Assemble-Remove-obsolete-test-for-kernels-older-than.patch
-DELETE   0078-Detail-Fixup-ugly-if-foo-abuse.patch
-DELETE   0079-Query-Handle-error-returned-by-fstat.patch
-DELETE   0080-Query-Use-sysfs-to-obtain-data-if-possible.patch
-DELETE   0081-sysfs-Parse-array_state-in-sysfs_read.patch
-DELETE   0082-util-Introduce-md_array_active-helper.patch
-DELETE   0084-maps-Use-keyvalue-for-null-terminator-to-indicate-un.patch
-DELETE   0085-util-Get-rid-of-unused-enough_fd.patch
-DELETE   0086-mdadm-retire-mdassemble-in-make-everything.patch
-DELETE   0090-Query-Quiet-gcc-since-it-cannot-know-errno-0-in-this.patch
-DELETE   0091-Makefile-Default-to-O2-optimization.patch
* Mon Jun 19 2017 colyli@suse.com
- 0093-Grow-don-t-allow-to-enable-PPL-when-reshape-is-in-pr.patch
  (bsc#1043553)
- 0094-Grow-don-t-allow-array-geometry-change-with-ppl-enab.patch
  (bsc#1043553)
* Sun Jun 11 2017 colyli@suse.com
- 0092-Grow-set-component-size-prior-to-array-size.patch
  (bsc#1042613)
* Fri Apr 28 2017 colyli@suse.com
- Update to latest upstream mdadm for SLE12-SP3, upto to
  commit 17d80e6eb642.
  (FATE#321941, FATE#321488)
- DELETE  0001-Generic-support-for-consistency-policy-and-PPL.patch
- DELETE  0002-Detail-show-consistency-policy.patch
- DELETE  0003-imsm-PPL-support.patch
- DELETE  0004-super1-PPL-support.patch
- DELETE  0005-Add-ppl-and-no-ppl-options-for-update.patch
- DELETE  0006-Grow-support-consistency-policy-change.patch
- DELETE  0007-udev-md-raid-assembly.rules-Skip-non-ready-devices.patch
- DELETE  0008-Retry-HOT_REMOVE_DISK-a-few-times.patch
- DELETE  0009-Introduce-sys_hot_remove_disk.patch
- DELETE  0010-Add-force-flag-to-hot_remove_disk.patch
- DELETE  0011-Detail-handle-non-existent-arrays-better.patch
  The above patches are not deleted indeed, they are renmaed with
  new prefix ID and included in bellowed patches.
- 0001-Makefile-Fix-date-to-be-output-in-ISO-format.patch
- 0002-imsm-fix-missing-error-message-during-migration.patch
- 0003-Fix-oddity-where-mdadm-did-not-recognise-a-relative-.patch
- 0004-mdadm-fix-typo-in-comment.patch
- 0005-mdadm-check-the-nodes-when-operate-clustered-array.patch
- 0006-examine-tidy-up-some-code.patch
- 0007-mdadm-add-man-page-for-symlinks.patch
- 0008-mdadm-add-checking-clustered-bitmap-in-assemble-mode.patch
- 0009-mdadm-Add-Wimplicit-fallthrough-0-in-Makefile.patch
- 0010-mdadm-Specify-enough-length-when-write-to-buffer.patch
- 0011-mdadm-fixed-some-trivial-typos-in-comments-of-mdadm..patch
- 0012-mdadm-it-doesn-t-make-sense-to-set-bitmap-twice.patch
- 0013-mdadm-mdmon-deleted-the-abort_reshape-never-invoked.patch
- 0014-mdadm-Monitor-Fix-NULL-pointer-dereference-when-stat.patch
- 0015-Replace-snprintf-with-strncpy-at-some-places-to-avoi.patch
- 0016-mdadm-Forced-type-conversion-to-avoid-truncation.patch
- 0017-super1-ignore-failfast-flag-for-setting-device-role.patch
- 0018-mdadm-bitmap-fixed-typos-in-comments-of-bitmap.h.patch
- 0019-udev-md-raid-assembly.rules-Skip-non-ready-devices.patch
  (bsc#956236)
- 0020-Retry-HOT_REMOVE_DISK-a-few-times.patch
  (bsc#808647)
- 0021-mdadm-Build-check-the-level-parameter-when-build-new.patch
- 0022-Introduce-sys_hot_remove_disk.patch
  (bsc#974154)
- 0023-Add-force-flag-to-hot_remove_disk.patch
  (bsc#808647)
- 0024-Detail-handle-non-existent-arrays-better.patch
  (bsc#966773)
- 0025-Generic-support-for-consistency-policy-and-PPL.patch
- 0026-Detail-show-consistency-policy.patch
- 0027-imsm-PPL-support.patch
- 0028-super1-PPL-support.patch
- 0029-Add-ppl-and-no-ppl-options-for-update.patch
- 0030-Grow-support-consistency-policy-change.patch
  Add support for Partial Parity Logs
  (FATE#321941)
- 0031-mdadm.h-struct-mdinfo-reorganize-ppl-elements-for-be.patch
- 0032-super1-replace-hard-coded-values-with-bit-definition.patch
- 0033-mdadm-Clean-up-some-ugly-multiple-actions-on-single-.patch
- 0034-mdadm-Fixup-a-number-of-whitespace-inconsistency-cas.patch
- 0035-util-Cosmetic-changes.patch
- 0036-Grow-Fixup-a-pile-of-cosmetic-issues.patch
- 0037-util-Introduce-md_get_array_info.patch
- 0038-Incremental-Remove-redundant-call-for-GET_ARRAY_INFO.patch
- 0039-util-Introduce-md_get_disk_info.patch
- 0040-util-Introduce-md_set_array_info.patch
- 0041-md_u-Remove-some-unused-ioctl-declarations.patch
- 0042-Grow-Remove-unnecessary-optimization.patch
- 0043-Grow-Do-not-shadow-an-existing-variable.patch
- 0044-mdadm-grow-reshape-would-be-stuck-from-raid1-to-raid.patch
- 0045-imsm-use-rounded-size-for-metadata-initialization.patch
- 0046-mdadm.c-fix-compile-error-switch-condition-has-boole.patch
- 0047-sysfs-Use-the-presence-of-sys-block-dev-md-as-indica.patch
- 0048-sysfs-Make-sysfs_init-return-an-error-code.patch
- 0049-mdadm-Create-declaring-an-existing-struct-within-sam.patch
- 0050-Create-Fixup-bad-placement-of-logical-in-multi-line-.patch
- 0051-Create-Fixup-various-whitespace-issues.patch
- 0052-util-must_be_container-Use-sysfs_read-GET_VERSION-to.patch
- 0053-util-set_array_info-Simplify-code-since-md_get_versi.patch
- 0054-Assemble-Assemble-Stop-checking-kernel-md-driver-ver.patch
- 0055-Build-Stop-bothering-about-supporting-md-driver-olde.patch
- 0056-Grow-Stop-bothering-about-md-driver-versions-older-t.patch
- 0057-Detail-Stop-bothering-about-md-drivers-older-than-0..patch
- 0058-Create-Remove-all-attemps-to-handle-md-driver-older-.patch
- 0059-Manage-Remove-all-references-to-md_get_version.patch
- 0060-Query-Remove-all-references-to-md_get_version.patch
- 0061-bitmap-Remove-use-of-md_get_version.patch
- 0062-mdmon-Stop-bothering-about-md_get_version.patch
- 0063-mdopen-open_mddev-Use-md_get_array_info-to-determine.patch
- 0064-mdassemble-Use-md_get_array_info-to-check-for-valid-.patch
- 0065-Assemble-Assemble-Get-rid-of-last-use-of-md_get_vers.patch
- 0066-util-Finally-kill-off-md_get_version.patch
- 0067-mdadm-Fail-for-kernels-older-than-2.6.15.patch
- 0068-mdadm.c-fix-compile-warning-mdfd-is-uninitialized.patch
- 0069-Revert-mdadm-grow-reshape-would-be-stuck-from-raid1-.patch
- 0070-Retire-mdassemble.patch
- 0071-super1-Clean-up-various-style-abuses.patch
- 0072-mdopen-use-parameters-new_array-to-create-arrays-whe.patch
- 0073-mdadm-manpage-update-manpage-for-readonly-parameter.patch
- 0074-mdadm-manpage-clustered-arrays-don-t-support-array-s.patch
- 0075-Assemble-Clean-up-start_array.patch
- 0076-Detail-Remove-pre-2.6-code-for-printing-info-on-rebu.patch
- 0077-Assemble-Remove-obsolete-test-for-kernels-older-than.patch
- 0078-Detail-Fixup-ugly-if-foo-abuse.patch
- 0079-Query-Handle-error-returned-by-fstat.patch
- 0080-Query-Use-sysfs-to-obtain-data-if-possible.patch
- 0081-sysfs-Parse-array_state-in-sysfs_read.patch
- 0082-util-Introduce-md_array_active-helper.patch
- 0083-maps-Terminate-modes-map-correctly.patch
- 0084-maps-Use-keyvalue-for-null-terminator-to-indicate-un.patch
- 0085-util-Get-rid-of-unused-enough_fd.patch
- 0086-mdadm-retire-mdassemble-in-make-everything.patch
- 0087-Grow_continue_command-ensure-content-is-properly-ini.patch
- 0088-systemd-mdadm-last-resort-use-ConditionPathExists-in.patch
- 0089-Detail-ensure-export-names-are-acceptable-as-shell-v.patch
- 0090-Query-Quiet-gcc-since-it-cannot-know-errno-0-in-this.patch
- 0091-Makefile-Default-to-O2-optimization.patch
* Thu Mar 30 2017 nfbrown@suse.com
- New upstream release 4.0
  Multiple bugfixes and various enhancements
  including IMSM support for bad blocks and 4K block devices.
  (FATE#321941)
- DELETE  0001-Fix-wrong-bitmap-output-for-cluster-raid.patch
- DELETE  0001-Remove-container-should-wait-for-an-array-to-release.patch
- DELETE  0001-fix-a-buffer-overflow.patch
- DELETE  0001-imsm-add-handling-of-sync_action-is-equal-to-idle.patch
- DELETE  0001-make-write_bitmap1-compatible-with-previous-versions.patch
- DELETE  0001-mdadm-add-clustered-in-typo-prompt-when-specify-wron.patch
- DELETE  0001-super1-Fix-bblog_size-accesses-on-big-ending-machine.patch
- DELETE  0001-udev-md-raid-assembly.rules-Skip-multipathed-devices.patch
- DELETE  0002-Fix-some-type-comparison-problems.patch
- DELETE  0002-Remove-dead-code-about-LKF_CONVERT-flag.patch
- DELETE  0002-imsm-properly-handle-values-of-sync_completed.patch
- DELETE  0003-Grow-goto-release-if-Manage_subdevs-failed.patch
- DELETE  0003-Makefile-make-the-CC-definition-conditional.patch
- DELETE  0003-monitor-Make-sure-that-last_checkpoint-is-set-to-0-a.patch
- DELETE  0004-Change-the-option-from-NoUpdate-to-NodeNumUpdate.patch
- DELETE  0004-Monitor-release-proc-mdstat-fd-when-no-arrays-presen.patch
- DELETE  0004-util.c-include-poll.h-instead-of-sys-poll.h.patch
- DELETE  0005-mdadm-Add-nodes-option-in-GROW-mode.patch
- DELETE  0005-mdadm.h-rename-bswap-macros-to-avoid-clash-with-uCli.patch
- DELETE  0006-Create-check-the-node-nums-when-create-clustered-rai.patch
- DELETE  0006-Manage.c-Only-issue-change-events-for-kernels-older-.patch
- DELETE  0007-super1-don-t-update-node-nums-if-it-is-not-more-than.patch
- DELETE  0008-super1-make-the-check-for-NodeNumUpdate-more-accurat.patch
- DELETE  0009-super1-add-more-checks-for-NodeNumUpdate-option.patch
- DELETE  1001-Fix-regression-during-add-devices.patch
- DELETE  1002-bnc808647-retry-failed-removes.patch
- DELETE  1003-failfast.patch
- DELETE  1004-display-timeout-status.patch
- DELETE  bnc966773_detail-ignore_empty_inactive_arrays.patch
- DELETE  mdadm-wait-for-remove.patch
  these were included upstream
- 0001-Generic-support-for-consistency-policy-and-PPL.patch
- 0002-Detail-show-consistency-policy.patch
- 0003-imsm-PPL-support.patch
- 0004-super1-PPL-support.patch
- 0005-Add-ppl-and-no-ppl-options-for-update.patch
- 0006-Grow-support-consistency-policy-change.patch
  Add support for Partial Parity Logs
  (FATE#321941)
- 0007-udev-md-raid-assembly.rules-Skip-non-ready-devices.patch
  (bsc#956236)
- 0008-Retry-HOT_REMOVE_DISK-a-few-times.patch
  (bsc#808647)
- 0009-Introduce-sys_hot_remove_disk.patch
  (bsc#974154)
- 0010-Add-force-flag-to-hot_remove_disk.patch
  (bsc#808647)
- 0011-Detail-handle-non-existent-arrays-better.patch
  (bsc#966773)
* Wed Nov  9 2016 zlliu@suse.com
- 0001-fix-a-buffer-overflow.patch
  super1.c: fix a buffer overflow
  (bsc#1007154)
- 0001-make-write_bitmap1-compatible-with-previous-versions.patch
  make write_bitmap1 compatible with previous mdadm versions
  (bsc#1007165)
* Thu Aug  4 2016 nfbrown@suse.com
- 0001-Remove-container-should-wait-for-an-array-to-release.patch
  Avoid race when removign drive from container
  (bsc#989373)
* Wed Aug  3 2016 zlliu@suse.com
- 0001-mdadm-add-clustered-in-typo-prompt-when-specify-wron.patch
  'clustered' bitmap has already supported, thus add the
  prompt if users specify wrong value for bitmap param.
  (bsc#991861)
* Fri Jul 15 2016 nfbrown@suse.com
- 0004-Monitor-release-proc-mdstat-fd-when-no-arrays-presen.patch
  cope with /proc/mdstat disappearing if md-mod
  module is removed
  (bsc#987811)
* Thu Jul 14 2016 nfbrown@suse.com
- mdadm-wait-for-remove.patch
  (bsc#974154)
- confirmed that bugs from earlier released are fixed
  (bsc#853944) (bsc#939124) (bsc#953595) (bsc#957886)
* Tue Jul 12 2016 nfbrown@suse.com
- 0001-udev-md-raid-assembly.rules-Skip-multipathed-devices.patch
  Ignore multipath devices when not yet ready.
  (bsc#956236)
- bnc966773_detail-ignore_empty_inactive_arrays.patch
  (bsc#966773)
* Wed Jun 22 2016 nfbrown@suse.com
- 0001-imsm-add-handling-of-sync_action-is-equal-to-idle.patch
  0002-imsm-properly-handle-values-of-sync_completed.patch
  0003-monitor-Make-sure-that-last_checkpoint-is-set-to-0-a.patch
  Fix problems with IMSM (Intel) arrays reshaping.
  (bsc#985026 bsc#985029)
* Thu May 19 2016 zlliu@suse.com
- bug fix for BSC#980327
  only put the templates @.service in filelist to ensure
  that zypper install/remove package without error printed.
* Wed May 11 2016 gqjiang@suse.com
- Add a patch to fix bsc#979454
  + 0009-super1-add-more-checks-for-NodeNumUpdate-option.patch
* Fri May  6 2016 gqjiang@suse.com
- Add a patch to fix bsc#978796
  + 0008-super1-make-the-check-for-NodeNumUpdate-more-accurat.patch
* Thu May  5 2016 gqjiang@suse.com
- Add cluster-md patches for mdadm v3.4 (fate#316335)
  + 0001-Fix-wrong-bitmap-output-for-cluster-raid.patch
  + 0002-Remove-dead-code-about-LKF_CONVERT-flag.patch
  + 0003-Grow-goto-release-if-Manage_subdevs-failed.patch
  + 0004-Change-the-option-from-NoUpdate-to-NodeNumUpdate.patch
  + 0005-mdadm-Add-nodes-option-in-GROW-mode.patch
  + 0006-Create-check-the-node-nums-when-create-clustered-rai.patch
  + 0007-super1-don-t-update-node-nums-if-it-is-not-more-than.patch
- Add udev rule and script for cluster-md
  + 69-clustermd.rules
  + clustermd-confirm.sh
* Thu Mar 10 2016 colyli@suse.com
- Update mdadm to v3.4, and include more upstream patches after v3.4
  version, (fate#320107, fate#320291)
  + 0001-super1-Fix-bblog_size-accesses-on-big-ending-machine.patch
  + 0002-Fix-some-type-comparison-problems.patch
  + 0003-Makefile-make-the-CC-definition-conditional.patch
  + 0004-util.c-include-poll.h-instead-of-sys-poll.h.patch
  + 0005-mdadm.h-rename-bswap-macros-to-avoid-clash-with-uCli.patch
  + 0006-Manage.c-Only-issue-change-events-for-kernels-older-.patch
- Since mdadm v3.4 release, remove these patches which are included
  in v3.4 already,
  - 0001-raid6check-don-t-ignore-return-value-from-posix_mema.patch
  - 0002-main-remove-use-of-uninitialized-rv.patch
  - 0003-Assemble-correctly-capture-error-from-write_bitmap.patch
  - 0004-tests-raid6-repair-is-now-tested-on-every-different-.patch
  - 0005-Makefile-test-s-flag-and-suppress-echo-when-set.patch
  - 0006-mdadm-remove-duplicate-logic-when-c.delay-is-0.patch
  - 0007-Increment-version-for-clustered-bitmaps.patch
  - 0008-super1-Do-not-create-bad-block-log-for-clustered-dev.patch
  - 0009-Fix-incremental-handling-on-cluster-array.patch
  - 0010-mdadm-make-cluster-raid-also-could-support-re-add.patch
  - 0012-re-add-make-re-add-try-to-write-sysfs-node-first.patch
  - 0013-imsm-don-t-call-abort_reshape-in-imsm_manage_reshape.patch
  - 0014-add-macros-for-MD_DISK_ROLE_-SPARE-FAULTY.patch
  - 0015-Show-device-as-journal-in-detail-examine.patch
  - 0016-Enable-create-array-with-write-journal-write-journal.patch
  - 0017-Assemble-array-with-write-journal.patch
  - 0018-Check-write-journal-in-incremental.patch
  - 0019-Add-help-message-and-man-entry-for-write-journal.patch
  - 0020-Safeguard-against-writing-to-an-active-device-of-ano.patch
  - 0021-Make-cmap_-also-has-same-policy-as-dlm_.patch
  - 0022-mdadm-refactor-write-journal-code-in-Assemble-and-In.patch
  - 0023-mdadm-Add-description-of-write-journal-to-md.4.patch
  - 0024-mdadm-add-test-script-for-raid456-journal.patch
  - 0025-add-crc32c-and-use-it-for-r5l-checksum.patch
  - 0026-ensure-buffer-is-large-enough-for-two-ints-and-some-.patch
  - 0027-avoid-confusion-with-parameter-devname-with-same-nam.patch
  - 0028-make-sure-path-buffer-is-large-enough-to-fit-200-cha.patch
  - 0029-fix-bug-in-assemble.patch
  - 0030-Detail.c-test-fix.patch
  - 0031-mdadm-Change-timestamps-to-unsigned-data-type.patch
  - 0032-add-sysfs_array_state-to-struct-mdinfo.patch
  - 0033-recreate-journal-in-mdadm.patch
  - 0034-mdadm-let-cluster-raid-could-also-add-disk-within-in.patch
  - 0035-mdadm-output-info-more-precisely-when-change-bitmap-.patch
  - 0036-mdadm-don-t-show-cluster-name-once-the-bitmap-is-cle.patch
  - 0037-mdadm-do-not-display-bitmap-info-if-it-is-cleared.patch
  - 0038-mdadm-do-not-try-to-hold-dlm-lock-in-free_super1.patch
  - 0039-mdadm-improve-the-safeguard-for-change-cluster-raid-.patch
  - 0040-Detail-report-correct-raid-disk-for-removed-drives.patch
  - 0041-Detail-don-t-assume-a-particular-disk-number-of-miss.patch
  - 0044-Add-update-force-no-bbl.patch
  - 0045-move-journal-to-end-of-detail-list.patch
  - 0046-in-add-assign-raid_disk-of-0-to-journal.patch
  - 0047-Check-and-remove-bitmap-first-when-reshape-to-raid0.patch
  - 0048-Detail-fix-wrong-condition-in-recent-change.patch
  - 0049-Grow-close-file-descriptor-earlier-to-avoid-still-in.patch
  - 0050-imsm-abort-reshape-if-sync_action-is-not-reshape.patch
  - 0051-IMSM-Add-support-for-VMD.patch
  - 0052-imsm-use-timeout-when-waiting-for-reshape-progress.patch
  - 0053-imsm-don-t-update-migration-record-when-reshape-is-i.patch
  - 0054-Fix-wrong-description-in-manpage.patch
  - 0055-restripe-fix-compilation-of-make-test.patch
  - 0056-Create-fix-regression-in-setting-raid_disk.patch
  - 0057-Create-minor-fix-when-adding-a-journal-device.patch
  - 0058-Define-_POSIX_C_SOURCE-if-undefined.patch
  - 0059-Add-casts-for-the-addr-arg-of-connect-and-bind.patch
* Thu Feb  4 2016 colyli@suse.com
- Update mdadm to v3.3.4 (with merged mdadm-3.3.x branch after
  v3.3.4 released), and include more upstream patches after v3.3.4
  version,
  (fate#320107, fate#320291)
  + 0001-raid6check-don-t-ignore-return-value-from-posix_mema.patch
  + 0002-main-remove-use-of-uninitialized-rv.patch
  + 0003-Assemble-correctly-capture-error-from-write_bitmap.patch
  + 0004-tests-raid6-repair-is-now-tested-on-every-different-.patch
  + 0005-Makefile-test-s-flag-and-suppress-echo-when-set.patch
  + 0006-mdadm-remove-duplicate-logic-when-c.delay-is-0.patch
  + 0007-Increment-version-for-clustered-bitmaps.patch
  + 0008-super1-Do-not-create-bad-block-log-for-clustered-dev.patch
  + 0009-Fix-incremental-handling-on-cluster-array.patch
  + 0010-mdadm-make-cluster-raid-also-could-support-re-add.patch
  + 0012-re-add-make-re-add-try-to-write-sysfs-node-first.patch
  + 0013-imsm-don-t-call-abort_reshape-in-imsm_manage_reshape.patch
  + 0014-add-macros-for-MD_DISK_ROLE_-SPARE-FAULTY.patch
  + 0015-Show-device-as-journal-in-detail-examine.patch
  + 0016-Enable-create-array-with-write-journal-write-journal.patch
  + 0017-Assemble-array-with-write-journal.patch
  + 0018-Check-write-journal-in-incremental.patch
  + 0019-Add-help-message-and-man-entry-for-write-journal.patch
  + 0020-Safeguard-against-writing-to-an-active-device-of-ano.patch
  + 0021-Make-cmap_-also-has-same-policy-as-dlm_.patch
  + 0022-mdadm-refactor-write-journal-code-in-Assemble-and-In.patch
  + 0023-mdadm-Add-description-of-write-journal-to-md.4.patch
  + 0024-mdadm-add-test-script-for-raid456-journal.patch
  + 0025-add-crc32c-and-use-it-for-r5l-checksum.patch
  + 0026-ensure-buffer-is-large-enough-for-two-ints-and-some-.patch
  + 0027-avoid-confusion-with-parameter-devname-with-same-nam.patch
  + 0028-make-sure-path-buffer-is-large-enough-to-fit-200-cha.patch
  + 0029-fix-bug-in-assemble.patch
  + 0030-Detail.c-test-fix.patch
  + 0031-mdadm-Change-timestamps-to-unsigned-data-type.patch
  + 0032-add-sysfs_array_state-to-struct-mdinfo.patch
  + 0033-recreate-journal-in-mdadm.patch
  + 0034-mdadm-let-cluster-raid-could-also-add-disk-within-in.patch
  + 0035-mdadm-output-info-more-precisely-when-change-bitmap-.patch
  + 0036-mdadm-don-t-show-cluster-name-once-the-bitmap-is-cle.patch
  + 0037-mdadm-do-not-display-bitmap-info-if-it-is-cleared.patch
  + 0038-mdadm-do-not-try-to-hold-dlm-lock-in-free_super1.patch
  + 0039-mdadm-improve-the-safeguard-for-change-cluster-raid-.patch
  + 0040-Detail-report-correct-raid-disk-for-removed-drives.patch
  + 0041-Detail-don-t-assume-a-particular-disk-number-of-miss.patch
  + 0044-Add-update-force-no-bbl.patch
  + 0045-move-journal-to-end-of-detail-list.patch
  + 0046-in-add-assign-raid_disk-of-0-to-journal.patch
  + 0047-Check-and-remove-bitmap-first-when-reshape-to-raid0.patch
  + 0048-Detail-fix-wrong-condition-in-recent-change.patch
  + 0049-Grow-close-file-descriptor-earlier-to-avoid-still-in.patch
  + 0050-imsm-abort-reshape-if-sync_action-is-not-reshape.patch
  + 0051-IMSM-Add-support-for-VMD.patch
  + 0052-imsm-use-timeout-when-waiting-for-reshape-progress.patch
  + 0053-imsm-don-t-update-migration-record-when-reshape-is-i.patch
  + 0054-Fix-wrong-description-in-manpage.patch
  + 0055-restripe-fix-compilation-of-make-test.patch
  + 0056-Create-fix-regression-in-setting-raid_disk.patch
  + 0057-Create-minor-fix-when-adding-a-journal-device.patch
  + 0058-Define-_POSIX_C_SOURCE-if-undefined.patch
  + 0059-Add-casts-for-the-addr-arg-of-connect-and-bind.patch
- Add 4 non-upstream patches which are inherited from SLE-12-SP1
  mdadm package,
  + 1001-Fix-regression-during-add-devices.patch
  + 1002-bnc808647-retry-failed-removes.patch
  + 1003-failfast.patch
  +1004-display-timeout-status.patch
- Update mdadm.spec to remove RPMLINT warning about systemd macro.
* Wed Jan  6 2016 neilb@suse.com
- 0001-Manage-fix-test-for-is-array-failed.patch
  Fix problem with adding spare to degraded array
  (bsc#958597)
* Wed Dec 23 2015 colyli@suse.com
- 0001-Detail-fix-handling-of-disks-array.patch
  0002-Detail-report-correct-raid-disk-for-removed-drives.patch
  0003-Detail-don-t-assume-a-particular-disk-number-of-miss.patch
  0004-Detail-fix-wrong-condition-in-recent-change.patch
  Fix mdadm detail information display issue on Number and RaidDevice
  fields.
  (bsc#954769)
* Fri Nov  6 2015 gqjiang@suse.com
- 0001-mdadm-remove-the-cluster-md-related-infos-from-doc.patch
  Since cluster-md is a EXPERIMENTAL feature for SLES-12-SP1, now
  we need to delete cluster-md related infos from document and udev
  rule as well.
  (fate#316335)
* Wed Nov  4 2015 colyli@suse.com
- 0001-Fix-regression-during-add-devices.patch
  Fix a regression introduced by Commit 38aeaf3a, patch is provided
  by Hannes Reinecke and committed by Coly Li.
  (bsc#953380)
* Tue Nov  3 2015 colyli@suse.com
- 0001-Manage-simplify-rdev-handling-in-Manage_subdevs.patch
  0002-util-split-get_maj_min-out-from-dev_open.patch
  0003-Manage-fix-removal-of-non-existent-devices.patch
  Fix bug that allowing other code to parse 8:3 style device names.
  (bsc#952644)
* Wed Oct 14 2015 nfbrown@suse.com
- 0001-DDF-_write_super_to_disk-fix-anchor-header-type.patch
  Fix bug with DDF handling on newer controllers
  (bsc#930417)
* Thu Oct  8 2015 nfbrown@suse.com
- 0001-re-add-make-re-add-try-to-write-sysfs-node-first.patch
  Futher md-cluster support
  (fate#316335 bsc#941697)
* Fri Oct  2 2015 nfbrown@suse.com
- 0001-IMSM-Clear-migration-record-on-disks-more-often.patch
  Ensure IMSM migration record cleared after a reshape
  (bsc#943028)
- 0002-imsm-simplified-multiple-OROMs-support.patch
  0002-IMSM-Count-arrays-per-orom.patch
  Don't create more IMSM array then OROM supports
  (bsc#943026)
- 0002-mdadm-make-cluster-raid-also-could-support-re-add.patch
  Further md-cluster support
  (fate#316335)
* Mon Sep 28 2015 nfbrown@suse.com
- 69-clustermd.rules: only run clustermd-confirm.sh if the
  'change' request is for adding a device to a clustered array.
- 0001-Increment-version-for-clustered-bitmaps.patch
  0002-Do-not-create-bad-block-log-for-clustered-devices.patch
  Update to match upstream version
- 0001-config-new-option-to-suppress-adding-bad-block-lists.patch
  0001-mdmon-don-t-include-super0-and-super1-in-mdmon.patch
  backported to support above updates.
  (fate#316335)
- 0004-mdadm-make-cluster-raid-also-could-support-re-add.patch
  Partial spport for --re-add in clusters
  (bsc#941697)
- 0001-Assemble-correctly-capture-error-from-write_bitmap.patch
  0002-main-remove-use-of-uninitialized-rv.patch
  Bug fixes in md-cluster patches.
  (fate#316335)
- 0003-Assemble-don-t-assemble-IMSM-array-without-OROM.patch
  0004-Assemble-really-don-t-assemble-IMSM-array-without-OR.patch
  Assembling an IMSM array when disabled in OROM can lead to
  data corruption.  So best to disable it.
  (bsc#939748 bsc#937363)
* Mon Sep 21 2015 gqjiang@suse.com
- Increment version for clustered bitmaps
  (bsc#940225)
  + 0001-Increment-version-for-clustered-bitmaps.patch
- Do not create bad block log for clustered devices
  (bsc#941530)
  + 0002-Do-not-create-bad-block-log-for-clustered-devices.patch
- Fix incremental to not create an array, but add to existing
  + 0003-Fix-incremental-to-not-create-an-array-but-add-to-ex.patch
* Tue Aug  4 2015 gqjiang@suse.com
- add "--cluser-confirm <slot>:missing" to clustermd-confirm.sh
  (bnc#940224)
* Thu Jul 30 2015 nfbrown@suse.com
- Improve support for latest Intel IMSM RAID
  (fate#318193)
  + 0001-imsm-support-for-OROMs-shared-by-multiple-HBAs.patch
  + 0002-imsm-support-for-second-and-combined-AHCI-controller.patch
  + 0003-imsm-add-support-for-NVMe-devices.patch
  + 0004-imsm-detail-platform-improvements.patch
  + 0005-imsm-use-efivarfs-interface-for-reading-UEFI-variabl.patch
* Thu Jul  2 2015 gqjiang@suse.com
- Add clustering options to mdadm
    (fate#316335)
    + 0001-Create-n-bitmaps-for-clustered-mode.patch
    + 0002-Add-nodes-option-while-creating-md.patch
    + 0003-Set-home-cluster-while-creating-an-array.patch
    + 0004-Show-all-bitmaps-while-examining-bitmap.patch
    + 0005-Add-a-new-clustered-disk.patch
    + 0006-Convert-a-bitmap-none-device-to-clustered.patch
    + 0007-Skip-clustered-devices-in-incremental.patch
    + 0008-mdadm-add-the-ability-to-change-cluster-name.patch
    + 0009-mdadm-change-the-num-of-cluster-node.patch
    + 0010-Reuse-calc_bitmap_size-to-reduce-code-size.patch
    + 0011-Safeguard-against-writing-to-an-active-device-of-ano.patch
* Wed Mar 25 2015 rgoldwyn@suse.com
- Add --cluster-confirm udev rule
    (fate#316335)
    + 69-clustermd.rules
    + clustermd-confirm.sh
* Tue Jul 22 2014 nfbrown@suse.com
- 0001-Grow-Do-not-try-to-restart-if-reshape-is-running.patch
  (bnc#887773)
* Tue Jul  8 2014 nfbrown@suse.com
- 0001-IMSM-Add-warning-message-when-assemble-spanned-conta.patch
  (bnc#882634)
* Mon Jul  7 2014 nfbrown@suse.com
- Remove mkinitrd scripts again.  They are now
  included in "libguestfs" so are not needed here.
  (bnc#883873)
* Thu Jun 26 2014 nfbrown@suse.com
- add mkinitrd scripts back in.  They are needed by
  "guestfs"
  (bnc#883873)
- 0001-Grow-fix-removal-of-line-in-wrong-case.patch
  (bnc#881530)
* Thu Jun 12 2014 nfbrown@suse.com
- mdadm.spec: change calling of mkinitrd to use the
  %%regenerate_initrd_{post,posttrans} macros to optimise
  initrd regeneration. (bnc#881780)
* Tue Jun 10 2014 nfbrown@suse.com
- update to new upstream version 3.3.1.  This includes nearly all
  the extra patches we had and also adds a number of DDF fixes.
  Also includes fixes for (bnc#881547 bnc#881530)
  DELETE  config-set-auto_seen-after-processing-the-auto-line.patch
  DELETE  DDF-allow-for-possibility-that-there-is-no-secondary.patch
  DELETE  Make-IRs-and-run-work-properly-for-containers.patch
  DELETE  mdmon-honour-offroot-again.patch
  DELETE  DDF-brief_examine_subarrays_ddf-print-array-name.patch
  DELETE  DDF-factor-out-array-name-generation.patch
  DELETE  DDF-handle-fake-RAIDs-with-changing-subarray-UUIDs.patch
  DELETE  DDF-compare_super_ddf-fix-sequence-number-check.patch
  DELETE  Monitor-don-t-set-arrays-dirty-after-transition-to-r.patch
  DELETE  DDF-add_to_super_ddf-be-careful-with-workspace_lba.patch
  DELETE  Monitor-write-meta-data-in-readonly-state-sometimes.patch
  DELETE  Assembe-fix-bug-in-force_array-it-wasn-t-forcing-pro.patch
  DELETE  Restructure-assemble_container_content-and-improve-m.patch
  DELETE  Incremental-add-export-handling.patch
  DELETE  udev-rules.degraded
  DELETE  Incremental-improve-support-for-DEVICE-based-restric.patch
  DELETE  Assemble-Incremental-don-t-hold-O_EXCL-on-mddev-afte.patch
  DELETE  mdmonitor
  DELETE  udev-rules-try-mdadm-I-on-change-events.patch
  DELETE  policy-NULL-path-isn-t-really-acceptable-use-the-dev.patch
  DELETE  DDF-really-ignore-DDF-metadata-on-partitions.patch
  DELETE  Assemble-avoid-infinite-loop-when-auto-assembling-pa.patch
  DELETE  DDF-fix-detection-of-failed-devices-during-assembly.patch
  DELETE  Grow-fix-problems-with-prematurely-aborting-of-resha.patch
  DELETE  IMSM-don-t-crash-when-creating-an-array-with-missing.patch
  DELETE  mdmon-don-t-complain-about-notifying-parent-when-the.patch
  DELETE  systemd-mdmon-set-IMSM_NO_PLATFORM-1.patch
  DELETE  mdmon-.service-remove-over-ride-of-Standard-IO.patch
  DELETE  0001-Assemble-allow-load_devices-to-change-the-st-which-i.patch
  DELETE  0002-Assemble-re-arrange-freeing-of-tst-in-load_devices.patch
  DELETE  0003-Assemble-change-load_devices-to-return-most_recent-s.patch
  DELETE  0001-mdmon-.service-Change-type-of-process-start-up-to-fo.patch
  DELETE  0003-Work-around-architectures-having-statfs.f_type-defin.patch
  DELETE  0004-DDF-report-seq-counter-as-events.patch
  DELETE  0005-DDF-when-first-activating-an-array-record-any-missin.patch
  DELETE  0001-DDF-mark-missing-on-assembly-device-properly.patch
  DELETE  0002-DDF-guard-against-pdnum-being-negative.patch
  DELETE  0003-DDF-fix-possible-mdmon-crash-when-updating-metadata.patch
  DELETE  0004-DDF-Don-t-fail-compare_super_ddf-due-to-re-configure.patch
  DELETE  0001-systemd-various-fixes-for-boot-with-container-arrays.patch
  DELETE  mdadm-add-spare.patch
  DELETE  0001-Create-don-t-default-to-bitmap-internal-when-it-is-n.patch
  DELETE  0001-Fix-race-between-create-and-incremental.patch
  DELETE  0001-imsm-retry-load_and_parse_mpb-if-we-suspect-mdmon-ha.patch
* Thu Jun  5 2014 nfbrown@suse.com
- 0001-imsm-retry-load_and_parse_mpb-if-we-suspect-mdmon-ha.patch
  upstream bugfix (bnc#881331)
* Tue May 27 2014 nfbrown@suse.com
- 0001-Create-don-t-default-to-bitmap-internal-when-it-is-n.patch
  0001-Fix-race-between-create-and-incremental.patch
  Upstream bugfixes (bnc#879918 bnc#879919)
* Mon Apr 14 2014 spargaonkar@suse.com
- added patches: mdadm-add-spare.patch
  Removed devices should be added as spare (FATE#313051)
* Fri Apr 11 2014 spargaonkar@suse.com
- mdadm-add-spare.patch
  Removed devices should be added as spare (FATE#313051)
* Fri Apr 11 2014 spargaonkar@suse.com
- add-spare changes
* Tue Apr  8 2014 nfbrown@suse.com
- 0001-systemd-various-fixes-for-boot-with-container-arrays.patch
  various fixes to improve boot-from-DDF or IMSM
  (bnc#866660)
* Wed Apr  2 2014 nfbrown@suse.com
- 0001-DDF-mark-missing-on-assembly-device-properly.patch
- 0002-DDF-guard-against-pdnum-being-negative.patch
- 0003-DDF-fix-possible-mdmon-crash-when-updating-metadata.patch
- 0004-DDF-Don-t-fail-compare_super_ddf-due-to-re-configure.patch
  More upstream DDF fixes (bnc#866660)
* Wed Mar 26 2014 nfbrown@suse.com
- 0001-mdmon-.service-Change-type-of-process-start-up-to-fo.patch
- 0003-Work-around-architectures-having-statfs.f_type-defin.patch
- 0004-DDF-report-seq-counter-as-events.patch
- 0005-DDF-when-first-activating-an-array-record-any-missin.patch
  Two fixes for DDF (bnc#866660) and a couple of other upstream fixes
  just for good measure.
* Tue Mar  4 2014 nfbrown@suse.com
- 0001-Assemble-allow-load_devices-to-change-the-st-which-i.patch
  0002-Assemble-re-arrange-freeing-of-tst-in-load_devices.patch
  0003-Assemble-change-load_devices-to-return-most_recent-s.patch
  Allow RAID5 to be assembled even when firs device listed recently
  failed (bnc#865221)
* Thu Jan 23 2014 nfbrown@suse.com
- failfast
- display-timeout-status
- bnc808647-retry-failed-removes.patch
  support for 'failfast' RAID10 configurations, (fate#311379)
* Wed Jan 22 2014 nfbrown@suse.com
- remove boot.md.  It no longer does anything useful.
* Wed Jan 22 2014 nfbrown@suse.com
- mdmonitor
  run "mdadm --monitor" from systemd instead of init.d
  sciprt (bnc#849523)
- remove mdadmd due to above.
- udev-rules-try-mdadm-I-on-change-events.patch
  (bnc#851993)
- policy-NULL-path-isn-t-really-acceptable-use-the-dev.patch
- DDF-really-ignore-DDF-metadata-on-partitions.patch
- Assemble-avoid-infinite-loop-when-auto-assembling-pa.patch
- DDF-fix-detection-of-failed-devices-during-assembly.patch
- Grow-fix-problems-with-prematurely-aborting-of-resha.patch
- IMSM-don-t-crash-when-creating-an-array-with-missing.patch
- mdmon-don-t-complain-about-notifying-parent-when-the.patch
- systemd-mdmon-set-IMSM_NO_PLATFORM-1.patch
- mdmon-.service-remove-over-ride-of-Standard-IO.patch
  Various upstream bug fixes.
* Wed Dec  4 2013 nfbrown@suse.com
- Assemble-Incremental-don-t-hold-O_EXCL-on-mddev-afte.patch
  Ensure fsck/mount don't find an md array to be BUSY
  the moment it appears.
- mkinitrd-setup.sh: Make the array device names in
  /etc/mdadm.conf in the initrd match those in /etc/mdadm.conf
  in the root filesystem.  (bnc#851993)
* Tue Dec  3 2013 nfbrown@suse.com
- Restructure-assemble_container_content-and-improve-m.patch
- Incremental-add-export-handling.patch
- udev-rules.degraded
- systemd-mdadm-last-resort@.service
- systemd-mdadm-last-resort@.timer
  Teach systemd to start degraded arrays after a timeout if
  some missing devices never appear (bnc#832501)
- Incremental-improve-support-for-DEVICE-based-restric.patch
  Teach "mdadm --incremental" to handle "DEVICE" lists from
  mdadm.conf properly (bnc@851993)
* Mon Nov 11 2013 nfbrown@suse.com
- DDF-handle-fake-RAIDs-with-changing-subarray-UUIDs.patch
- DDF-compare_super_ddf-fix-sequence-number-check.patch
- Monitor-don-t-set-arrays-dirty-after-transition-to-r.patch
- DDF-add_to_super_ddf-be-careful-with-workspace_lba.patch
- Monitor-write-meta-data-in-readonly-state-sometimes.patch
- Assembe-fix-bug-in-force_array-it-wasn-t-forcing-pro.patch
  Various bugfixes from upstream - several to improve
  DDF support, one which fixes a nasty bug in "--assemble --force".
* Wed Nov  6 2013 nfbrown@suse.com
- DDF-brief_examine_subarrays_ddf-print-array-name.patch
  DDF-factor-out-array-name-generation.patch
  Include name in "-Db" output for DDF
  FATE#316007
* Fri Sep 13 2013 nfbrown@suse.com
- boot.md - simplify boot.
  As array assembly is done by udev, it shouldn't
  be done by boot.md.  This will avoid some problems
  with arrays getting started degraded.
* Fri Sep 13 2013 nfbrown@suse.com
- Make-IRs-and-run-work-properly-for-containers.patch
- mdmon-honour-offroot-again.patch
- DDF-allow-for-possibility-that-there-is-no-secondary.patch
  Upstream fixes
* Thu Sep 12 2013 nfbrown@suse.com
- config-set-auto_seen-after-processing-the-auto-line.patch
  Fix bug which causes "AUTO -all" in mdadm.conf
  in initrd to be ignored, so array might be
  auto-assembled too early.
* Thu Sep 12 2013 nfbrown@suse.com
- mkinitrd-boot.sh: simplify boot sequence by relying
  completely on udev running "mdadm -I".  Thus
  mkinitrd-boot.sh needs to do very little.
  The devfunction script in the mkinitrd package has
  been modified to start newly degraded array after
  a suitable timeout.
- mkinitrd-setup.sh:
  - don't save md_devs as it isn't used any more
  - allow md device names like "/dev/md_foo" which will
    need to be supported in due course.
* Mon Sep  9 2013 nfbrown@suse.com
- mkinitd-boot.sh: Clear {root,resume}_major variable
  If multipath is in use, md is always on top of it. Therefore, the root
  device is always an md device. (bnc#786526)
* Fri Sep  6 2013 nfbrown@suse.com
- mkinitrd-setup.sh: copy new udev rules files into
  the initrd.
  The "mkinitrd" package does this for the old name.
  It is easier if this packages does it for the files
  this package installs.
  (bnc#838777)
* Tue Sep  3 2013 nfbrown@suse.com
- New upstream release - mdadm-3.3
  Lot of improvements to --grow and DDF support.
  Better interaction with systemd.
  Hot-replace support and more.
  Removes patches:
    assemble-EXCL-race.fix
    0001-Add-support-for-launching-mdmon-via-systemctl-instea.patch
    0002-In-case-launching-mdmon-fails-print-an-error-message.patch
    0003-mdmon-add-foreground-option.patch
    0004-Suppress-error-messages-from-systemctl.patch
  which were backports from upstream.
* Thu Jun 13 2013 nfbrown@suse.com
- assemble-EXCL-race.fix: avoid some races during
  array assembled- particularly at boot (bnc#793954)
- boot.md: make sure systemd-udev-trigger runs before
  boot.md to avoid races: bnc#793954
- mdmon@.service - new file plus patches to allow
  mdmon to be started by systemd, so it doesn't
  kill it (bnc#321366)
* Tue Apr 16 2013 idonmez@suse.com
- Add Source URL, see https://en.opensuse.org/SourceUrls
* Wed Feb 27 2013 cfarrell@suse.com
- license update: GPL-2.0
  mdadm/Software-RAID.HOWTO.tar.bz2
* Sun Nov  4 2012 crrodriguez@opensuse.org
- Fix factory breakage on udev and systemd rules.
* Thu Oct 25 2012 nfbrown@suse.com
- new upstream release 3.2.6.  Subsumes all of our
  patches and adds a lot of other bug fixes for
  less common cases including for a couple that cause
  mdadm to crash.
* Tue Oct  9 2012 nfbrown@suse.com
- remove /lib/udev/devices from specfile as it is
  unused
- mkinitrd-setup.sh: fixed recent breakage for IMSM
  arrays (bnc#783444)
* Thu Sep 20 2012 nfbrown@suse.com
- mdmon-takeover.fix
  find-free-devnum.fix
  mapfile-rebuild.fix
  udev-offroot
  Fix various issues will installation on IMSM
  RAID arrays, booting from those arrays, and
  clean shutdown when such an array is used for '/'.
  (bnc#752107 bnc#732294 bnc#770351)
- mkinitrd-setup.sh: allow use stable md device name
  and allow it to have a ':' in it. (bnc#779087)
- boot.md: make sure udev-trigger runs before
  boot.md. (bnc#772286)
* Mon Aug 20 2012 nfbrown@suse.com
- mdmon-takeover.fix
  find-free-devnum.fix
  mapfile-rebuild.fix
  udev-offroot
  Fix various issues will installation on IMSM
  RAID arrays, booting from those arrays, and
  clean shutdown when such an array is used for '/'.
  (bnc#752107 bnc#732294 bnc#770351)
* Thu Jul 26 2012 fcrozat@suse.com
- Add blkid-builtin.patch: use blkid built-in from udev
* Thu Jul  5 2012 nfbrown@suse.com
- mdmon-arg.fix: fix arg parsing in mdmon so that
  "--all --takeover" works. (bnc#767150)
* Thu Jun 21 2012 meissner@suse.com
- use recommends: smtp_daemon, similar to cronie example
* Thu Jun 14 2012 opensuse@cboltz.de
- add missing dependencies on cron and /usr/sbin/sendmail (bnc#767155)
* Thu May 24 2012 nfbrown@suse.com
- udev-rules.fix: make sure systemd doesn't try
  to mount array before it is fully assembled.
  (bnc#752869)
* Tue May 22 2012 nfbrown@suse.com
- boot.md/mkinitrd-boot.sh: complete any incremental
  assembly before attempting to assemble arrays.
  If incremental assembly has partialy assembled
  degraded arrays, now is the time to start them going.
  (bnc#752869)
- mdamd.cron: send daily reports if any arrays are
  degraded.
* Fri May 18 2012 nfbrown@suse.com
- New upstream version: 3.2.5.  Serious regression
  in 3.2.4 necessitated a new release.  Only significant
  fix is that "--add" now works again.
* Wed May  9 2012 nfbrown@suse.com
- New upstream version: 3.2.4. /run/mdadm is not
  used for runtime files, not /var/run or /dev/.mdadm.
* Fri Apr 20 2012 rmilasan@suse.com
- Run update of initrd at %%post and %%postun.
  We need this to make sure initrd reflects the updates.
* Wed Dec 21 2011 coolo@suse.com
- remove call to suse_update_config (very old work around)
* Thu Oct  6 2011 nfbrown@suse.com
- mkinitrd-setup.sh -- add "AUTO -all" to initrd mdadm.conf
  so that only arrays needed for boot are auto-assembled.
- auto-line.fix -- fix handling of "AUTO" line
  in mdadm.conf so it actually works.
  (bnc#721905)
* Fri Sep 30 2011 uli@suse.com
- cross-build fix: use %%__cc macro
* Thu Aug 18 2011 nfbrown@novell.com
- boot.md: improve 'status' and add 'reload'
  function.  Also change 'Raid' to 'RAID'
  for consistency (bnc#709474)
* Thu Aug 18 2011 nfbrown@novell.com
- Use udev rules file from upstream package, rather
  have having a separate one.
* Thu Aug 18 2011 nfbrown@novell.com
- Update to new upstream 3.2.2 plug git patches.
  Also update FSF address in boot-md.
* Wed Aug 10 2011 crrodriguez@opensuse.org
- Do not use -fno-strict-aliasing when not needed
* Tue Jun 14 2011 nfbrown@novell.com
- 64-md-raid.rules - make clear distinction between
  'disk' and 'partition' cases.  In particular it
  is wrong and problematic to test for 'md/array_state'
  for 'partition' devices as they cannot see 'md/*'
  and cannot exist when it doesn't have a valid value
  anyway. (bnc#684291)
* Tue Mar  1 2011 nfbrown@novell.com
- mkinitrd-boot.sh: don't assume /dev/md when device
  name cannot be found.  It could easily be wrong,
  and there is no need as mdadm will choose a device.
  (bnc#656536)
* Thu Feb 17 2011 nfbrown@novell.com
- 64-md-raid.rules: avoid races with md devices
  appearing and disappearing.
  If the 'array_state' file doesn't exist, that is equivalent
  to it having 'clear' in it. (bnc#641382)
* Wed Nov 17 2010 nfbrown@novell.com
-  boot.md - change args to mdmon.
  The argument parsing of mdmon changed in the recent update
  and we need to change boot.md to match.
* Thu Oct 21 2010 ro@suse.de
- update to 3.1.4
  - Support --grow to change the layout of RAID4/5/6
  - Support --grow to change the chunksize of raid 4/5/6
  - Support --grow to change level from RAID1 -> RAID5 -> RAID6 and
    back.
  - Support --grow to reduce the number of devices in RAID4/5/6.
  - Support restart of these grow options which assembling an array
    which is partially grown.
  - Assorted tests of this code, and of different RAID6 layouts.
  - The default metadata is now v1.2
  - The default chunksize is now 512K rather than 64K.  This seems more
    appropriate for modern devices.
  - The default bitmap chunksize for internal bitmaps is now at least
    64Meg as fine grained bitmaps tend to impact performance more for
    little extra gain.
  - Alway make bitmap 4K-aligned if at all possible.
- removed patches:
  - bitmap-4k-boundary.patch (obsolete/upstream)
  - fix-dup.patch (obsolete/upstream)
  - IMSM-part.patch (obsolete/upstream)
  - container-argv-check (obsolete/upstream)
* Mon Jun 28 2010 jengelh@medozas.de
- use %%_smp_mflags
* Tue Jun  1 2010 mmarek@suse.cz
- mkinitrd-setup.sh: Fix for empty $md_devs variable.
* Fri Apr 23 2010 nfbrown@novell.com
- IMSM-part.patch - never try to include partitions in an
  IMSM array - bnc#597787
- container-argv-check - avoid incorrect error message when
  assembling multiple containers - bnc#598827
* Thu Apr 22 2010 mmarek@suse.cz
- mkinitrd-boot.sh: Fix booting with root=/dev/disk/by-id/md-uuid*,
  run mdadm -v when linuxrc=trace is given (bnc#597787).
* Mon Apr 19 2010 nfbrown@novell.com
- fix-dup.patch: revised version to make sure partial
  device is destroyed properly (bnc#587925).
* Fri Mar 26 2010 mmarek@suse.cz
- fix-dup.patch: catch attempts to add the same disk twice
  (bnc#587925).
* Wed Mar 24 2010 mmarek@suse.cz
- 64-md-raid.rules: Use absolute path to grep, otherwise udev will
  only search in /lib/udev (bnc#590832).
* Tue Mar 23 2010 mmarek@suse.cz
- mkinitrd-*.sh: Assemble md arrays even if the root= or resume=
  option doesn't directly refer to md (bnc#589676, bnc#586837,
  bnc#583424).
* Mon Mar 22 2010 mmarek@suse.cz
- mdmon: Fix crash if /proc/mdstat lists 0.9 superblocks
  (bnc#589447).
* Thu Mar 11 2010 mmarek@suse.cz
- 64-md-raid.rules: Use blkid instead of vol_id.
* Thu Mar 11 2010 mmarek@suse.cz
- 64-md-raid.rules: Allow --incremental assembly if "AUTO -all" is
  given in mdadm.conf (fate#307478).
* Tue Mar  9 2010 mmarek@suse.cz
- Install udev rules in /lib/udev/rules.d (fate#307478).
* Mon Feb 22 2010 mmarek@suse.cz
- mkinitrd-setup.sh: call mdadm --scan only if necessary
  (bnc#581769).
* Fri Feb 19 2010 mmarek@suse.cz
- bitmap-4k-boundary.patch: Alling the internal bitmap on 4K
  boundary (bnc#577468).
* Fri Jan 15 2010 mmarek@suse.cz
- fix modprobe invocation in boot.md (bnc#565293).
* Fri Jan 15 2010 mmarek@suse.cz
- store mdmon runtime files in /dev/.mdadm, to make it easier to
  transfer mdmon from the initrd to the real root.
- rework the mkinitrd setup script a bit.
* Wed Jan  6 2010 mmarek@suse.cz
- mkinitrd-*.sh: fix booting from partitionable md devices and
  from container devices (bnc#565219).
* Tue Dec 15 2009 jengelh@medozas.de
- enable parallel building
* Fri Dec  4 2009 mmarek@suse.cz
- Support for partitionable md devices in mkinitrd scripts
  (fate#305883).
* Tue Nov  3 2009 mmarek@suse.cz
- update to 3.0.3 (fate#307159)
  * mdmon improvements (needed for fate#306823)
  * other fixes
* Fri Oct 30 2009 mmarek@suse.cz
- mkinitrd-boot.sh: add /sbin/mdmon to the initrd (fate#306823).
* Thu Oct  1 2009 mmarek@suse.cz
- updated to 3.0.2 + 2 patches
  * bugfixes only
* Fri Jun 12 2009 mmarek@suse.cz
- remove static md* device nodes, they should not be needed
  anymore.
* Thu Jun 11 2009 mmarek@suse.cz
- updated to 3.0 final
- dropped all patches
* Tue Mar  3 2009 mmarek@suse.cz
- super0:  Do all metadata IO with 4096byte alignment
- super1 - do metadata IO in sector_size units.
  (bnc#466172)
* Sat Feb 21 2009 mmarek@suse.cz
- mkinitrd-setup.sh: filter out duplicate devices (bnc#461673,
  patch by Xin Wei Hu)
* Tue Feb 17 2009 mmarek@suse.cz
- disable auto-assemly in boot.md completely as it can collide with
  dmraid (bnc#474652). If someone wants to auto-assemble md arrays
  in the rescue system, they can run
  'mdadm -Es -c partitions >mdadm.conf && mdadm -As -c mdadm.conf'
  manually.
* Mon Feb 16 2009 mmarek@suse.cz
- fix segfault when stopping imsm arrays
  (bnc#473947, patch by Dan Williams)
* Mon Jan 26 2009 ro@suse.de
- change fillup call from "-Y" to "-y" the boot script has
  been present in this package for long enough (SLES10-GA)
* Fri Dec  5 2008 hare@suse.de
- Wait for udev to settle before continuing (bnc#435778)
* Fri Dec  5 2008 nfbrown@suse.de
- boot.md : an exit status of '2' from "mdadm --assemble"
  should not be seen as failure by boot.md.
  It happens if one or more arrays is already
  assembled.
  (bnc#456028)
* Thu Nov 20 2008 nfbrown@suse.de
- don-t-auto-assemble-if-any-arrays-are-list.patch
  Avoid assembling extra arrays during initrd
  processing. bnc#445438
* Thu Nov 20 2008 nfbrown@suse.de
- mdmon-pass-symbolic-name-to-mdmon-instead-of-device.patch
  avoid problems if mdmon is run before
  udev creates any devices.
* Fri Nov 14 2008 nfbrown@suse.de
- intel.fixes.patch : various fixes from intel for
  proper handling of their metadata
- name.fixes.patch : various fixes for new handling
  of device names - one could cause a crash.
* Sun Nov  9 2008 ro@suse.de
- fix patch apply depth
* Fri Nov  7 2008 nfbrown@suse.de
- mdadm-auto-assemble.patch - fix various bugs in
  auto-assemble
- start-kpartx-for-imsm-devices.patch - IMSM devices
  need to be partitioned, and may programs including
  YaST don't understand partitioned md devices,
  so run kpartx to create 'dm' based partitions which
  have a better chance for being understood
  This relates to FATE#304220
* Fri Nov  7 2008 ro@suse.de
- remove udev rule (conflicting with file in udev package)
* Fri Nov  7 2008 ro@suse.de
- buildfix: add missing DESTDIR to Makefile for udev rule
- fix len in snprintf to silence compiler warning about potential
  overflow
* Thu Nov  6 2008 nfbrown@suse.de
- Update from mdadm-3.0-devel1 to mdadm-3.0-devel2.
  This includes various bug fixes and enhancements to the
  extent that DDF and IMSM work reasonably well and can be
  auto-assembled much like other arrays.
- Allow BOOT_MD_USE_MDADM_CONFIG to have the value 'part'
  that, like 'no', arrays are auto-assembled.  However they
  get assembled as 'mdp' partitionable arrays where possible.
  This currently only affect arrays with v1.x metadata.
  This supports FATE#303894
* Fri Oct  3 2008 mmarek@suse.cz
- fixed mdmon's clone_monitor on ia64
* Fri Oct  3 2008 mmarek@suse.cz
- fixed byte swapping in super-intel.c on big endian.
* Wed Sep 24 2008 ro@suse.de
- change "udevsettle" to "udevadm settle"
* Fri Sep 19 2008 mmarek@suse.cz
- added /var/run/mdadm for mdmon
- fixed build
* Thu Sep 18 2008 nfbrown@suse.de
- update to mdadm-3.0-devel1
  package version number is set to 3.0 to avodi future confusion.
  This is a substantial update that provides support for handling
  the metadata entirely in userspace and thus making easier to
  handle a variety of metadata formats.  Support is included for
  DDF and for the Intel Matrix metadata used by recent ICH chipsets.
  An extra program 'mdmon' is needed and included.  It is run to
  monitor any array using 'external' (to the kernel) metadata
  and will update the metadata in response to device failures etc.
  This is required for FATE 304219
* Wed Sep  3 2008 hare@suse.de
- Call mkinitrd_setup during %%post and %%postun (bnc#413709)
* Sun Aug 17 2008 aj@suse.de
- Fix init scripts.
* Wed Jul 23 2008 hare@suse.de
- Include mkinitrd scriptlets.
* Fri Jun 20 2008 mmarek@suse.cz
- updated to 2.6.7 + fixes from git
  * Avoid segfault when parsing /proc/mdstat with auto-read-only
    arrays.
  * For v0.90 superblocks, print the 'Events' count as a real
    count, not 2 numbers separated by a dot.
  * Allow creation of a RAID6 with exactly one missing device.
  * Use LOG_PID for syslog, so you get the pid of mdadm in the
    log files.
  * --export now works with --examine too (not just --detail)
  * Improve auto-creation of device special file when using
  - -incremental
  * Simple locking for --incremental so mdadm doesn't get
    confused when run concurrently with itself.
  * Make --incremental cope better with arrays that are being
    reshaped.
  * Fix autoassemble for stack arrays.
- remove /tmp/mdadm.conf in boot.md (bnc#401138)
* Wed Apr 30 2008 mmarek@suse.cz
- added some fixes from Neil's git repo, fixing bnc#368704 among
  others
* Mon Feb  4 2008 mmarek@suse.cz
- correctly display rc_status in boot.md
* Wed Jan 23 2008 mmarek@suse.cz
- fixed auto-assembly part of boot.md
  * if /etc/mdadm.conf is empy or only contains whitespace or
    comments, no autoassembly is done
  * remove /tmp/mdadm.conf even if a directory [#329678]
- dropped mdrun and raidautorun (no longer needed)
* Wed Oct 24 2007 mmarek@suse.cz
- updated to 2.6.4
  * Make "--create --auto=mdp" work for non-standard device names.
  * Fix restarting of a 'reshape' if it was stopped in the middle.
  * Fix a segfault when using v1 superblock.
  * Make --write-mostly effective when re-adding a device to an
    array.
  * Various minor fixes
- changes in 2.6.3:
  * allow --write-behind to be set for --grow.
  * When adding new disk to an array, don't reserve so much bitmap
    space that the disk cannot store the required data. (Needed
    when 1.x array was created with older mdadm).
  * When adding a drive that was a little too small, we did not get
    the correct error message.
  * Make sure that if --assemble find an array in the critical
    region of a reshape, and cannot find the critical data to
    restart the reshape, it gives an error message.
  * Fix segfault with '--detail --export' and non-persistent
    superblocks.
  * Various manpage updates.
  * Improved 'raid4' support (--assemble, --monitor)
  * Option parsing fixes w.r.t -a
  * Interpret "--assemble --metadata=1" to allow any version 1.x
    metadata, and be more specific in the "metadata=" message
    printed with --examine --brief
  * Fix spare migration in --monitor.
* Fri Jul 27 2007 mmarek@suse.cz
- changes to the init script [#288454]
  * don't try to autoassemble if /etc/mdadm.conf exists (even an
    empty one)
  * ony autoassemble partitions found in /proc/partitions
* Fri Jul 13 2007 mmarek@suse.cz
- updated to 2.6.2
  * --fail detached and --remove faulty can be used to fail and
    remove devices that are no longer physically present.
  * --export option for --detail or present information in a format
    that can be processed by udev.
  * fix internal bitmap allocation problems with v1.1, v1.2
    metadata.
  * --help now goes to stdout so you can direct it to a pager.
  * Various manpage updates.
  * Make "--grow --add" for linear arrays really work.
  * --auto-detect to trigger in-kernel autodetect.
  * Make return code for "--detail --test" more reliable.  Missing
    devices as well as failed devices cause an error.
- added some fixes from Neil's git repo (mdadm-git-fixes.patch)
* Thu Jun 21 2007 adrian@suse.de
- fix changelog entry order
* Mon Apr  2 2007 mmarek@suse.cz
- updated to 2.6.1
  * --monitor was producing some meaningless warnings due to a bug.
  * Fix some compiler warnings.
  * Fully support --grow for raid6.  If a reshape crashed during
    the critical period, mdadm wouldn't restore the Q information
    properly.
  * Update documentation for --grow.
  * Report bitmap status in --detail and --examine
  * Default to v1 superblocks instead of v0.90 if the array
    is too big for 0.90 to handle.
  * Sort the output of "mdadm --detail --scan" so that it is
    in a suitable order for assembling arrays. i.e. components come
    before an array that they are part of.
  * Require bitmap files to have a '/' in their name.
  * Rewrite 'reshape' support including performing a backup
    of the critical region for a raid5 growth, and restoring that
    backup after a crash.
  * Put a 'canary' at each end of the backup so a corruption
    can be more easily detected.
  * Support --backup-file for backing-up critical section during
    growth.
  * Erase old superblocks (of different versions) when creating new
    array.
  * Allow --monitor to work with arrays with >28 devices
  * Report reshape information in --detail
  * Handle symlinks in /dev better
  * Fix mess in --detail output which a device is missing.
  * Support 'bitmap=' in mdadm.conf for auto-assembling arrays with
    write-intent bitmaps in separate files.
  * Fix alignment problem in version-1 superblocks.
    NOTE: This is an incompatable change affecting raid5 reshape.
    If you want to reshape a raid5 using version-1 superblocks,
    use 2.6.17-rc2 or later, and mdadm-2.4.1 or later.
  * Support 'mailfrom' line in mdadm.conf so the From: line in alert
    emails can be explicitly set.
  * Arrange that SparesMissing (which is similar in import to
    DegradedArray) generates an Email.
  * Assume "DEVICE partitions" if no DEVICE line is given.
  * Support new 'offset' layout for raid10.
  * When creating a bitmap file, choose a chunksize to limit number
    of bitmap chunks to 2 million.  More than this can cause kmalloc
    failure.
  * New 'CREATE' line in mdadm.conf for defaults such as owner, group,
    mode and auto-flag
  * --detail checks if array has been started or not and includes that
    in report.
  * When using --update=uuid on an array with a bitmap, update the
    bitmap's uuid too.
  * Add a copy of /proc/mdstat to the mail message sent by mdadm
  - -monitor.
  * New flag --no-degraded to avoid starting arrays if there are
    fewer devices available than last time the array was started.
    This is only needed with --scan, as with --scan, that behaviour
    is the default.
  * Support for 'homehost' concept.  This is a fairly major update.
    It includes a configfile option and a command line option for
    specifying a homehost, records that host in the superblock,
    and reports the homehost where possible.
  * Support for Auto Assembly.  "mdadm -As" will, if provided with
    the name of a homehost, try to assemble all arrays it can find
    that were created for that homehost.  See man pages for more details.
  * Don't try to create devices with --manage or --grow
  * allow default metadata (superblock) type to be specified
    in mdadm.conf
  * Avoid some misdetection of overlapping partitions
  * Add 'Array Slot' line to --examine for version-1 superblocks
    to make it a bit easier to see what is happening.
  * Work around bug in --add handling for  version-1 superblocks
    in 2.6.17 (and prior).
  * Make -assemble a bit more resilient to finding strange
    information in superblocks.
  * When creating devices in /dev/md/ create matching symlinks
    from /dev.  e.g. /dev/md0 -> /dev/md/0.
    Allow this to be disabled in mdadm.conf or on command line.
  * Allow a number (of partitions) after the 'yes' option to --auto=
    This is particularly useful in the 'create' line in mdadm.conf.
  * Remove partitions from any whole device that is made part of
    an md array.  This is a work-around for annoying messages
    when the first block on some drive accidentally looks like a
    partition table.
  * Close stray fd in mdassemble so that it can assemble stacked
    devices
  * If mdassemble finds an array already assembled, it marks it
    read-write.
  * Remove error in md_open if array is already active.  This isn't
    needed and gets in the ways if an array was created e.g. in
    initramfs, but device doesn't yet exist in /dev.
  * When --assemble --scan is run, if all arrays that could be found
    have already been started, don't report an error.
  * Allow --assemble --force to mark a raid6 clean when it has two
    missing devices (which is needed else if won't assemble.
    Without this fix it would only assemble if one or zero
    missing devices.
  * Support --update=devicesize for cases where the underlying device
    can change size.
  * Default to --auto=yes so the array devices with 'standard' names
    get created automatically, as this is almost always what is wanted.
  * Give useful message if raid4/5/6 cannot be started because it is
    not clean and is also degraded.
  * Increase raid456 stripe cache size if needed to --grow the array.
    The setting used unfortunately requires intimate knowledge of the
    kernel, and it not reset when the reshape finishes.
  * Change 'Device Size' to 'Used Dev Size' because it only shows how
    much of each device is actually used, not how big they are.
  * --wait or -W will wait for resync activity to finish on the given
    devices.
  * If two drives in a raid5 disappear at the same time, then "-Af"
    will add them both in rather than just one and forcing the array
    to 'clean'.  This is slightly safer in some cases.
  * Don't hold md device open for so long in --monitor mode - map_dev
    can be slow and interferes with trying to stop the array.
  * Support --uuid= with --create to choose your own UUID.
  * New major more "--incremental" for incremental assemble of arrays,
    intended for use with udev.
  * lots of bugfixes
  * manpage updates
* Wed Jan 10 2007 mmarek@suse.cz
- use raidautorun instead of mdrun to autodetect the raid arrays in
  boot.md [#230733]
* Wed Nov  8 2006 prusnak@suse.cz
- fixed subscript out of range [#212697]
* Wed Sep 20 2006 mjancar@suse.cz
- update to 2.5.3
  * lots bugfixes
  * drop all patches (integrated upstream)
* Fri Jul 28 2006 olh@suse.de
- remove dropped boot.ibmsis from boot.md
- boot.rootfsck should start before boot.md (#181972)
* Fri Jul 21 2006 olh@suse.de
- remove boot.proc from Required-Start: in boot.md (#178753)
* Wed May  3 2006 mjancar@suse.cz
- fix false SparesMissing error (#171326)
* Wed Apr 26 2006 hare@suse.de
- Fix init script dependencies
- Implement MDADM_DEVICE_TIMEOUT to set a timeout for
  udevsettle (#149979)
* Tue Apr 25 2006 mjancar@suse.cz
- add static device nodes for udev (#168824)
* Wed Apr 19 2006 mjancar@suse.cz
- set $BOOT_MD_USE_MDADM_CONFIG to "yes" by default (#155120)
* Fri Apr  7 2006 mjancar@suse.cz
- detach mdadmd from tty in rcmdadmd (#160881)
* Mon Apr  3 2006 mjancar@suse.cz
- fix garbled output with --detail (#160827)
- fix fix write-mostly with --add and --re-add (#162968)
* Fri Mar 24 2006 mjancar@suse.cz
- add /sbin/raidautorun (#159460)
* Wed Mar  8 2006 mjancar@suse.cz
- add $BOOT_MD_USE_MDADM_CONFIG sysconfig variable (#155120)
* Thu Feb  9 2006 mjancar@suse.cz
- round free size to chunk size multiply on --create (#148562)
* Tue Feb  7 2006 mjancar@suse.cz
- move boot.multipath to Should-Start instead of Required-Start
* Mon Feb  6 2006 mjancar@suse.cz
- add "Obsoletes: raidtools"
- start boot.md after boot.multipath
- call mdadm without -a from mdrun, an argument is required in 2.2
* Mon Feb  6 2006 mjancar@suse.de
- don't start mdadmd by default
* Sun Feb  5 2006 mjancar@suse.cz
- include option for email to be sent on start (#142105)
- fix missing md autostart due to raidtools dropped (#148234)
  * include mdrun script from Debian
  * create boot.md initscipt
* Sun Feb  5 2006 schwab@suse.de
- Fix memset parameters.
* Thu Feb  2 2006 mjancar@suse.cz
- fix segfault on --assemble (#146514)
* Fri Jan 27 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Wed Jan 25 2006 olh@suse.de
- fix uninitialized variable, memset call and memcmp/memcpy bug
  mdadm.bug144647-array.init.patch
  mdadm.bug144647-update_super1-memcpy.patch
  mdadm.bug144647-add_internal_bitmap0-memcpy.patch
* Wed Jan 11 2006 mjancar@suse.cz
- update ro 2.2
* Tue Dec 20 2005 ro@suse.de
- at least output errors if they occur (instead of ignoring)
* Wed Nov 30 2005 schwab@suse.de
- Fix broken formats.
* Tue Oct 25 2005 aj@suse.de
- Build with -fno-strict-aliasing.
* Wed Oct 12 2005 mjancar@suse.cz
- update to 2.1
* Thu Jul 28 2005 anicka@suse.cz
- update to 1.12.0
* Wed Jun 15 2005 meissner@suse.de
- use RPM_OPT_FLAGS correctly.
* Tue Apr 19 2005 postadal@suse.de
- updated to version 1.11.0
- fixed for gcc 4.0
- removed obsoleted patch config-fix
* Wed Mar 30 2005 postadal@suse.cz
- fixed parsing command line option '--config=partions' [#74603]
* Fri Feb  4 2005 postadal@suse.cz
- updated to version 1.9.0
* Thu Jan 13 2005 postadal@suse.cz
- updated to version 1.8.1
- extended comment in sysconfig.mdadm [#48567]
* Fri Aug  6 2004 postadal@suse.cz
- updated to version 1.6.0
  * added --auto= and --assume-clean options
  * added "degraded" and "recovering" options to the "Status:" entry
* Tue Feb 10 2004 postadal@suse.cz
- updated to version 1.5.0
  * new commands "mdassemble"
  * support for raid6 as found in 2.6.2
  * support partitioned md arrays with a different major number and
    naming scheme
  * added "SparesMissing" event when --monitor first sees an array and
    it doesn't have the enough spare devices.
* Sun Jan 11 2004 adrian@suse.de
- add %%defattr
* Mon Dec  1 2003 fehr@suse.de
- fix quoting problem in start script (#33392)
* Fri Aug 29 2003 fehr@suse.de
- add PreReq for fillup
* Tue Aug 26 2003 fehr@suse.de
- add %%stop_on_removal and %%restart_on_update
* Thu Aug 14 2003 fehr@suse.de
- add missing activation metadata in sysconfig (#28901)
* Tue Jul 29 2003 fehr@suse.de
- update to new version 1.3.0 of package
* Mon Apr 14 2003 postadal@suse.cz
- fixed init script (added return value for unimplemented reload function)
* Mon Mar 31 2003 postadal@suse.cz
- added buildroot, init script, sysconfig
- bzip2 sources and cleaned specfile
* Thu Mar 20 2003 fehr@suse.de
- update to version 1.2.0 of package
* Mon Mar  3 2003 fehr@suse.de
- update to version 1.1.0 of package
* Mon Dec  2 2002 fehr@suse.de
- Fix for new glibc/gcc
* Tue Sep 17 2002 ro@suse.de
- removed bogus self-provides
* Fri Sep 13 2002 lmb@suse.de
- Fix for 64bit arch; ioctl returns long instead of int (#20339)
* Fri Aug 23 2002 lmb@suse.de
- Multipath arrays can now be build manually even without a superblock.
- One debugging chunk removed from patch.
* Tue Aug 13 2002 lmb@suse.de
- Fix for the assembly of multipath arrays.
* Mon Aug 12 2002 lmb@suse.de
- Added patch to support the enhanced multipath features.
* Mon Aug  5 2002 fehr@suse.de
- make SuSE package from version 1.0.1 of mdadm
